# -*- coding: utf-8 -*-
#
#   rayopt - raytracing for optical imaging systems
#   Copyright (C) 2012 Robert Jordens <robert@joerdens.org>
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU Lesser General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.

from __future__ import print_function, absolute_import, division

from .material import *
from .elements import *
from .pupils import *
from .conjugates import *
from .system import *
from .raytrace import *
from .paraxial_trace import *
from .gaussian_trace import *
from .geometric_trace import *
from .poly_trace import *
from .optimize import *

from . import library
from .library import Library
from . import analysis
from .analysis import Analysis

from .formats import (system_from_text,
                      system_from_yaml, system_to_yaml,
                      system_from_json, system_to_json)

from . import zemax, oslo, rii
from .oslo import len_to_system
from .zemax import zmx_to_system
